<?php
$start_time = microtime();
$start_array = explode(" ",$start_time);
$start_time = $start_array[1] + $start_array[0];
// ######################## SET PHP ENVIRONMENT ###########################
error_reporting(E_ALL & ~E_NOTICE);

// ##################### DEFINE IMPORTANT CONSTANTS #######################
define('THIS_SCRIPT', 'ipsearch'); 

// #################### PRE-CACHE TEMPLATES AND DATA ######################
// pre-cache templates used by all actions
$globaltemplates = array(
    'ipsearch_form',
    'ipsearch_bits',
    'navbar',
    'pagenav',
);

// ########################## REQUIRE BACK-END ############################
require_once('./global.php');
// ########################################################################
// ######################### START MAIN SCRIPT ############################
// ########################################################################
ini_set('display_errors', 1);
$search_name = '';
$ipsearch_bits = '';
if (!isset($_GET['ip']) || empty($_GET['ip'])) {
    if (isset($_POST['ip']) && !empty($_POST['ip'])) {
        for ($i = 0; $i < strlen(trim($_POST['ip'])); $i++) {
            if (preg_match("/[^0-9\.]/isU", $_POST['ip']{$i})) {
                $_POST['ip']{$i} = '';
            }
        }
        $search_name = trim($_POST['ip']);
        unset($_POST['ip']);
    }
} else {
    for ($i = 0; $i < strlen(trim($_GET['ip'])); $i++) {
        if (preg_match("/[^0-9\.]/isU", $_GET['ip']{$i})) {
            $_GET['ip']{$i} = '';
        }
    }
    $search_name = trim($_GET['ip']);
}

//if do=search
//check permissions
$arr_perm = explode(",", $vbulletin->userinfo['membergroupids']);
if (($permissions['usergroupid'] < 5) && !in_array(5, $arr_perm) && !in_array(6, $arr_perm) && !in_array(7, $arr_perm)) {
    print_no_permission();
} else {
    $navbits = array(); 
    $navbits[] = construct_phrase($vbphrase['ipsearch_outtitle']);
    //check $_GET['do']
    if ((($_GET['do'] == 'search') || !empty($_GET['ip'])) && !empty($search_name)) {
        //get list, where name or IP-address like searching string
 
        //to pagenav
        $vbulletin->input->clean_array_gpc('r', array(
            'perpage' => TYPE_INT,
            'page' => TYPE_INT
        ));
        if(empty($vbulletin->GPC['page'])) {
            $page = 1;
        } else {
            $page = $vbulletin->GPC['page'];
        }
        if(empty($vbulletin->GPC['perpage'])) {
            $perpage = 10;
        } else {
            $perpage = $vbulletin->GPC['perpage'];
        }
        
        $query_count_us = $db->query_first_slave("
            SELECT COUNT(*) as count
            FROM " . TABLE_PREFIX . "post
            WHERE visible = 1 AND ipaddress LIKE '" . $search_name . "%'
        ");
        $count_us = $query_count_us['count'];
        if ($count_us > 0) {
            $query = $db->query_read("
                SELECT DISTINCT " . TABLE_PREFIX . "post.postid, " . TABLE_PREFIX . "post.username, " . TABLE_PREFIX . "post.userid, " . TABLE_PREFIX . "post.title, " . TABLE_PREFIX . "post.threadid, " . TABLE_PREFIX . "post.dateline,
                " . TABLE_PREFIX . "post.pagetext, " . TABLE_PREFIX . "thread.title as thread_title,
                " . TABLE_PREFIX . "thread.postusername as author, " . TABLE_PREFIX . "thread.dateline as create_at, " . TABLE_PREFIX . "thread.threadid as thread_id
                FROM " . TABLE_PREFIX . "post
                LEFT JOIN " . TABLE_PREFIX . "thread ON " . TABLE_PREFIX . "thread.threadid=" . TABLE_PREFIX . "post.threadid
                LEFT JOIN " . TABLE_PREFIX . "postparsed ON " . TABLE_PREFIX . "postparsed.postid=" . TABLE_PREFIX . "post.postid
                WHERE " . TABLE_PREFIX . "post.ipaddress LIKE '" . $search_name . "%' AND " . TABLE_PREFIX . "thread.visible=1
                ORDER BY " . TABLE_PREFIX . "post.postid DESC
                LIMIT " . (($page-1) * $perpage) . ", " . $perpage . "
            ");
            $count_res = $db->num_rows($query);
            if ($count_res > 0) {
                //if found at least 1 row
                $posts = $authors = $thread_ids = $threads = $dates = array();
                //sort derived data
                for ($i = 0; $i < $count_res; $i++) {
                    $res = $db->fetch_array($query);
                    if (!in_array($res['thread_title'], $threads)) {
                        array_push($threads, $res['thread_title']);
                        array_push($authors, $res['author']);
                        array_push($dates, $res['create_at']);
                        array_push($thread_ids, $res['thread_id']);
                    }
                    $posts[$i]['id'] = $res['postid'];
                    $posts[$i]['title'] = $res['title'];
                    $posts[$i]['text'] = $res['pagetext'];
                    $posts[$i]['date'] = $res['dateline'];
                    $posts[$i]['thread'] = $res['threadid'];
                    $posts[$i]['userid'] = $res['userid'];
                    $posts[$i]['username'] = $res['username'];
                }
                for ($i = 0; $i < sizeof($threads); $i ++) {
                    //for every threads
                
                    //prepare date for header template
                    $ipsearch_post['theme'] = '<a href="showthread.php?t=' . $thread_ids[$i] . '">' . $threads[$i] . '</a>';
                    $ipsearch_post['date'] = date("d.m.Y H:i:s", $dates[$i]);
                    $ipsearch_post['author'] = $authors[$i];
                    $ipsearch_post['total'] = $count_us;
                    $ipsearch_post['ip'] = $search_name;
                    //fetch header template
                    eval('$ipsearch_bits .= "' . fetch_template('ipsearch_bits_header') . '";');
                    for ($j = 0; $j < sizeof($posts); $j ++) {
                        //for every posts
                                        
                        if ($posts[$j]['thread'] == $thread_ids[$i]) {
                            //preparation post text
                            $text = htmlspecialchars($posts[$j]['text']);
                            //delete all BB-codes
                            $text = preg_replace(array('/\[.*\].*\[\/.*\]/isU', '/\[\/.*\]/'), '', $text);
                            if (strlen($text) > 150) {
                                $text = substr($text, 0, 150);
                                $text .= '...';
                            }
                            //prepare date for data template
                            $post_id = $posts[$j]['id'];
                            if (empty($posts[$j]['title'])) {
                                $post_title = construct_phrase($vbphrase['ipsearch_notheme']);
                            } else {
                                $post_title = $posts[$j]['title'];
                            }
                            $post_date = date("d.m.Y H:i:s", $posts[$j]['date']);
                            $post_text = $text;
                            if (0 != $posts[$j]['userid']) {
                                $post_user = '<a href="member.php?u=' . $posts[$j]['userid'] . '">' . $posts[$j]['username'] . '</a>';
                            } else {
                                $post_user = $posts[$j]['username'] . ' ' . construct_phrase($vbphrase['ipsearch_noreg']);
                            }
                            //fetch data template
                            eval('$ipsearch_bits .= "' . fetch_template('ipsearch_bits') . '";');
                        }
                    }
                }
                //add pagenav
                $pagenav = construct_page_nav($page, $perpage, $count_us, "ipsearch.php?ip=" . $search_name,"");    
            } else {
                eval('$ipsearch_bits .= "<tr align=\"center\"><td colspan=\"3\" class=\"panelsurround\">' . construct_phrase($vbphrase['ipsearch_noresult']) . '</td></tr>";');
            }
        } else {
            eval('$ipsearch_bits .= "<tr align=\"center\"><td colspan=\"3\" class=\"panelsurround\">' . construct_phrase($vbphrase['ipsearch_noresult']) . '</td></tr>";');
        }
    }
    $end_time = microtime();
    $end_array = explode(" ",$end_time);
    $end_time = $end_array[1] + $end_array[0];
    $time = $end_time - $start_time;
    eval('$elapsed_time .= "' . number_format(($time * 1000), 2, '.', '') . '";');
    //add navbar
    $navbits = construct_navbits($navbits);
    eval('$navbar = "' . fetch_template('navbar') . '";
        print_output("' . fetch_template('ipsearch_form') . '");');
}
?> 